//credits: enttec, soriak

#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings



using System.Runtime.InteropServices;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;


namespace VVVV.Nodes
{
    public class OpenDMX
    {

        public static byte[] buffer = new byte[513];
        public static uint handle;
        public static bool done = false;
        public static bool Connected = false;
        public static int bytesWritten = 0;
        public static FT_STATUS status;

        public const byte BITS_8 = 8;
        public const byte STOP_BITS_2 = 2;
        public const byte PARITY_NONE = 0;
        public const UInt16 FLOW_NONE = 0;
        public const byte PURGE_RX = 1;
        public const byte PURGE_TX = 2;
	

        [DllImport("FTD2XX.dll")]
        public static extern FT_STATUS FT_Open(UInt32 uiPort, ref uint ftHandle);
        [DllImport("FTD2XX.dll")]
        public static extern FT_STATUS FT_Close(uint ftHandle);
        [DllImport("FTD2XX.dll")]
        public static extern FT_STATUS FT_Read(uint ftHandle, IntPtr lpBuffer, UInt32 dwBytesToRead, ref UInt32 lpdwBytesReturned);
        [DllImport("FTD2XX.dll")]
        public static extern FT_STATUS FT_Write(uint ftHandle, IntPtr lpBuffer, UInt32 dwBytesToRead, ref UInt32 lpdwBytesWritten);
        [DllImport("FTD2XX.dll")]
        public static extern FT_STATUS FT_SetDataCharacteristics(uint ftHandle, byte uWordLength, byte uStopBits, byte uParity);
        [DllImport("FTD2XX.dll")]
        public static extern FT_STATUS FT_SetFlowControl(uint ftHandle, char usFlowControl, byte uXon, byte uXoff);
        [DllImport("FTD2XX.dll")]
        public static extern FT_STATUS FT_GetModemStatus(uint ftHandle, ref UInt32 lpdwModemStatus);
        [DllImport("FTD2XX.dll")]
        public static extern FT_STATUS FT_Purge(uint ftHandle, UInt32 dwMask);
        [DllImport("FTD2XX.dll")]
        public static extern FT_STATUS FT_ClrRts(uint ftHandle);
        [DllImport("FTD2XX.dll")]
        public static extern FT_STATUS FT_SetBreakOn(uint ftHandle);
        [DllImport("FTD2XX.dll")]
        public static extern FT_STATUS FT_SetBreakOff(uint ftHandle);
        [DllImport("FTD2XX.dll")]
        public static extern FT_STATUS FT_GetStatus(uint ftHandle, ref UInt32 lpdwAmountInRxQueue, ref UInt32 lpdwAmountInTxQueue, ref UInt32 lpdwEventStatus);
        [DllImport("FTD2XX.dll")]
        public static extern FT_STATUS FT_ResetDevice(uint ftHandle);
        [DllImport("FTD2XX.dll")]
        public static extern FT_STATUS FT_SetDivisor(uint ftHandle, char usDivisor);
		
    	public static Task writeThread;

        public static void start()
        {
        	
            handle = 0;
        	
            status = FT_Open(0, ref handle);
                //setting up the WriteData method to be on it's own thread. This will also turn all channels off
                //this unrequested change of state can be managed by getting the current state of all channels 
                //into the write buffer before calling this function.
            //Task writeThread = new Task(new Action(writeData));
        	
        	//writeThread = Task.Factory.StartNew(() => writeData(Enttec_DMXOpenDMXNode.isSending()));
            //writeThread.Start();
        	
        }

        public static void setDmxValue(int channel, byte value)
        {
            if (buffer != null)
            {
                buffer[channel ] = value;
            }
        }
		
    
    	
        public  static void writeData()
        {
        	
                try
                {
                	
	                    initOpenDMX();
	                    if (OpenDMX.status == FT_STATUS.FT_OK)
	                    {
	                        status = FT_SetBreakOn(handle);
	                        status = FT_SetBreakOff(handle);
	                        bytesWritten = write(handle, buffer, buffer.Length);
							Thread.Sleep(25); //give the system time to send the data before sending more
	                       
	                    }
                		
                	
                }
                catch (Exception exp)
                {
                    //Console.WriteLine(exp);
                }
        		
        	

        }

        public static int write(uint handle, byte[] data, int length)
        {
            try
            {
                IntPtr ptr = Marshal.AllocHGlobal((int)length);
                Marshal.Copy(data, 0, ptr, (int)length);
                uint bytesWritten = 0;
                status = FT_Write(handle, ptr, (uint)length, ref bytesWritten);
                return (int)bytesWritten;
            }
            catch (Exception exp)
            {
                Console.WriteLine(exp);
                return 0;
            }
        }

        public static void initOpenDMX()
        {
            status = FT_ResetDevice(handle);
            status = FT_SetDivisor(handle, (char)12);  // set baud rate
            status = FT_SetDataCharacteristics(handle, BITS_8, STOP_BITS_2, PARITY_NONE);
            status = FT_SetFlowControl(handle, (char)FLOW_NONE, 0, 0);
            status = FT_ClrRts(handle);
            status = FT_Purge(handle, PURGE_TX);
            status = FT_Purge(handle, PURGE_RX);
        }

    }

    /// <summary>
    /// Enumaration containing the varios return status for the DLL functions.
    /// </summary>
    public enum FT_STATUS
    {
        FT_OK = 0,
        FT_INVALID_HANDLE,
        FT_DEVICE_NOT_FOUND,
        FT_DEVICE_NOT_OPENED,
        FT_IO_ERROR,
        FT_INSUFFICIENT_RESOURCES,
        FT_INVALID_PARAMETER,
        FT_INVALID_BAUD_RATE,
        FT_DEVICE_NOT_OPENED_FOR_ERASE,
        FT_DEVICE_NOT_OPENED_FOR_WRITE,
        FT_FAILED_TO_WRITE_DEVICE,
        FT_EEPROM_READ_FAILED,
        FT_EEPROM_WRITE_FAILED,
        FT_EEPROM_ERASE_FAILED,
        FT_EEPROM_NOT_PRESENT,
        FT_EEPROM_NOT_PROGRAMMED,
        FT_INVALID_ARGS,
        FT_OTHER_ERROR
    };





	#region PluginInfo
	[PluginInfo(Name = "OpenDMX", Category = "Enttec,DMX", AutoEvaluate = true, Help = "openDMX and FTD2xx",Credits = "soriak", Tags = "")]
	#endregion PluginInfo
	public class Enttec_DMXOpenDMXNode : IPluginEvaluate, IDisposable
	{
		#region fields & pins
		[Input("Input", MinValue = 0, MaxValue = 1)]
		public ISpread<float> FInput;
		
		[Input("Send", DefaultBoolean = false, IsBang = true, IsSingle = true)]
		public ISpread<bool> FInSend;
		
		[Input("Reset", DefaultBoolean = false, IsBang = true, IsSingle = true)]
		public ISpread<bool> FInReset;
		
		
		
		[Output("Output")]
		public ISpread<String> FStatus;
		
		[Output("IsConnected")]
		public ISpread<bool> FIsConnected;
		
		//[Output("debug")]
		//public ISpread<int> FDebug;
		
		
		
		private bool firstrun = true;
		private bool _isSending = false;
		
		
		

		[Import()]
		public ILogger FLogger;
		#endregion fields & pins
		
		public Task writeTask;
		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			if(writeTask != null && !writeTask.IsCompleted)
				return;
			
			FInput.SliceCount = SpreadMax;
			FStatus.SliceCount = 1;
			
			_isSending = FInSend[0];
			
			if(firstrun || FInReset[0]){
			
				try
	            {
	            	OpenDMX.FT_Close(OpenDMX.handle);
	                OpenDMX.start(); 				//find and connect to devive (first found if multiple)
	            	if ( OpenDMX.status == FT_STATUS.FT_DEVICE_NOT_FOUND)       //update status
	                    FStatus[0] = "No Enttec USB Device Found";
	                else if (OpenDMX.status == FT_STATUS.FT_OK)
	                    FStatus[0] = "Found DMX on USB";
	                else{
	                    FStatus[0] = OpenDMX.status.ToString();

	                }	            	
	            	
	            	firstrun = false;
	            	
	            	if(OpenDMX.status == FT_STATUS.FT_OK)
						FIsConnected[0] = true;
					else
						FIsConnected[0] = false;
	            	
	            }
	            catch (Exception exp)
	            {
	                FLogger.Log(LogType.Error,exp.ToString());
	                FStatus[0] = "Error Connecting to Enttec USB Device";
	
	            }
				
			}
			
			
			if(_isSending){
				for (int i = 0; i < SpreadMax; i++)
					{
						OpenDMX.setDmxValue(i+1, verifyInput (FInput[i]*255));
						//FDebug[i] = (byte) (FInput[0]*255);
					}
					
					if(writeTask == null || writeTask.IsCompleted){
						writeTask = new Task(new Action(OpenDMX.writeData));
						writeTask.Start();
						//FLogger.Log(LogType.Debug, "completed");
						
								
					}				
					
				
				if(OpenDMX.status == FT_STATUS.FT_OK)
					FIsConnected[0] = true;
				else{
					FIsConnected[0] = false;
					firstrun = true;
				}
					
					
	
				//FLogger.Log(LogType.Debug, "hi tty!");
					
			}
			
		}
		
		private byte verifyInput(float _input)
		{
			if(_input<0)
				return 0;
			else if(_input>255)
				return 255;
			else
				return (byte) (_input);
		}
		
		public void Dispose(){
			//FLogger.Log(LogType.Debug,"closing port");
			OpenDMX.FT_Close(OpenDMX.handle);
		}
	}
}
